"""
#################################### 
#        hTP_SimpleDM              #
#                                  #
#     many thanks to:              # 
#            TP_Pred               #
#            british_assassin       #
#            SuperDave             #
####################################
"""

import es
import random
import popuplib
import gamethread
import playerlib
import datetime
import services

from configobj import ConfigObj
from sqlite3 import dbapi2 as sqlite

info = es.AddonInfo()
info['name']        = "hTP_SimpleDM"
info['version']     = "beta1"
info['author']      = "HitThePipe and Predator"
info['url']         = "http://forums.mattie.info/cs/forums/index.php"
info['description'] = "CSS:DM In Python for ES"

class connection(object):
    def __init__(self,path):
        self.con = sqlite.connect(path)
        self.cur = self.con.cursor()
    def execute(self,sql):
        self.cur.execute(sql)
        self.con.commit()
    def query(self,sql):
        self.cur.execute(sql)
        return self.cur.fetchall()
    def close(self):
        self.con.close()

dm_config = ConfigObj(es.getAddonPath('htp_dm') + '/dm_config.ini')

rw = 0
cplayers = {}
auth = services.use('auth')
mkills = int(dm_config['settings']['rank_min_kills']) - 1
ranks_limit = int(dm_config['settings']['ranks_limit']) + 1
prefix = ('#green' + dm_config['settings']['message_prefix'] + '#default')
db = connection(es.getAddonPath('htp_dm') + '/usersettings.db')


def load():
    global DDKills
    global DMMain
    global DMMenuP
    global DMMenuR1
    global ranks

    es.set('hTP_SimpleDM','v.beta1')
    es.makepublic('hTP_SimpleDM')

    if not es.exists('saycommand', 'guns'):
        es.regsaycmd('guns', 'htp_dm/send_main', 'Send Main Menu')
    if not es.exists('saycommand', 'ammo'):
        es.regsaycmd('ammo', 'htp_dm/stock_ammo', 'Restock Ammo')
    if not es.exists('saycommand', 'stats'):
        es.regsaycmd('stats', 'htp_dm/stats', 'Show player stats')
    if not es.exists('saycommand', 'rank'):
        es.regsaycmd('rank', 'htp_dm/rank', 'Show player rank')
    if not es.exists('saycommand', 'top'):
        es.regsaycmd('top', 'htp_dm/top_ranks', 'Show Top# menu')        
    if not es.exists('saycommand', 'resetranks'):
        es.regsaycmd('resetranks', 'htp_dm/reset_ranks', 'Reset ranks- Admin cmd')
    if not es.exists('saycommand', 'ranks'):
        es.regsaycmd('ranks', 'htp_dm/ranks', 'Show rank range')
    if not es.exists('command', 'c_ranks'):
        es.regcmd('c_ranks', 'htp_dm/ranks', 'Server cmd')

    auth.registerCapability("resetranks", auth.ADMIN)
        
    db.execute("CREATE TABLE IF NOT EXISTS [UserSettings] ([SteamID]VARCHAR(30) UNIQUE NOT NULL,[Name]VARCHAR(30),[Rifle]VARCHAR(30),[Pistol]VARCHAR(30),[SendMenu]INT,[Kills]INT,[Deaths]INT,[KD]VARCHAR(10),[LastConnect]VARCHAR(30))")

    set_ranks()   
	
    DMMain = popuplib.create('dmm_popup')
    DMMain.addline('hTP:SimpleDM Main Menu')
    DMMain.addline('------------------')
    DMMain.addline('->1. New Weapons')
    DMMain.addline('->2. Previous Weapons')
    DMMain.addline('->3. Always use Same')
    DMMain.addline('->4. Restock Ammo')
    DMMain.menuselect = main_menuselect
    
    DDKills = popuplib.create('dmkills_popup')
    DDKills.addline('Stats')
    DDKills.addline('----------------')
    DDKills.addline('Kills :')
    DDKills.addline('Deaths :')
    DDKills.addline('K/D Ratio :')
    DDKills.addline('-----------------')
    DDKills.addline('->0. Exit')
    
    DMMenuP = popuplib.easymenu('dmp_popup', None, menup_menuselect)
    DMMenuP.settitle('Select Pistol')
    DMMenuP.addoption('weapon_glock', "Glock")
    DMMenuP.addoption('weapon_usp', "USP")
    DMMenuP.addoption('weapon_deagle', "Deagle")
    DMMenuP.addoption('weapon_p228', "P228")
    DMMenuP.addoption('weapon_fiveseven', "FiveSeven")
    DMMenuP.addoption('weapon_elite', "Elites")

    DMMenuR1 = popuplib.easymenu('dmr1_popup',None, menur1_menuselect)
    DMMenuR1.settitle('Select Primary')
    DMMenuR1.addoption('weapon_m4a1', "M4A1")
    DMMenuR1.addoption('weapon_ak47', "AK47")
    DMMenuR1.addoption('weapon_awp', "AWP")
    DMMenuR1.addoption('weapon_famas', "Famas")
    DMMenuR1.addoption('weapon_galil', "Galil")
    DMMenuR1.addoption('weapon_sg552', "Sg552")
    DMMenuR1.addoption('weapon_aug', "AUG")
    DMMenuR1.addoption('weapon_scout', "Scout")
    DMMenuR1.addoption('weapon_sg550', "Sg550")
    DMMenuR1.addoption('weapon_g3sg1', "G3Sg1")
    DMMenuR1.addoption('weapon_m3', "M3")
    DMMenuR1.addoption('weapon_xm1014', "Xm1014")
    DMMenuR1.addoption('weapon_m249', "M249")
    DMMenuR1.addoption('weapon_tmp', "TMP")
    DMMenuR1.addoption('weapon_mac10', "Mac10")
    DMMenuR1.addoption('weapon_mp5navy', "MP5")
    DMMenuR1.addoption('weapon_ump45', "UMP")
    DMMenuR1.addoption('weapon_p90', "P90")
    
    for player in es.getUseridList():
        steamid = es.getplayersteamid(player)
        getPlayer(player, steamid)
        gamethread.delayed(2, es.server.cmd, 'est_spawn %s 1' % player)       

    es.msg('#multi', '%s hTP_SimpleDM is now on.' %prefix)   	

def main_menuselect(userid, choice, popupid):
    if choice == 1:
        if not popuplib.isqueued('dmp_popup', userid):
            DMMenuP.send(userid)
    elif choice == 2:
        muser = playerlib.getPlayer(userid)
        if muser.get('teamid') > 1:
            GiveWeapons(userid)
    elif choice == 3:
        GiveWeapons(userid)	
        cplayers[userid] = (cplayers[userid][0],cplayers[userid][1],'0')
        es.tell (userid, '#multi', '%s type \'guns\' to re-enable the menu' %prefix)
    elif choice == 4:
        auser = playerlib.getPlayer(userid)
        auser.set('ammo', ['primary', '120'])
        auser.set('ammo', ['secondary', '120'])

def menup_menuselect(userid, choice, popupid):
    if not popuplib.isqueued('dmr1_popup', userid):
        DMMenuR1.send(userid)
    cplayers[userid] = (cplayers[userid][0],choice,cplayers[userid][2])
    db.execute("UPDATE UserSettings SET Pistol='%s' WHERE SteamID='%s'" % (choice, es.getplayersteamid(userid)))
	
def menur1_menuselect(userid, choice, popupid):
    cplayers[userid] = (choice,cplayers[userid][1],cplayers[userid][2]) 
    muser = playerlib.getPlayer(userid)
    if muser.get('teamid') > 1:
        GiveWeapons(userid)	
    steamid = es.getplayersteamid(userid)
    db.execute("UPDATE UserSettings SET Rifle='%s' WHERE SteamID='%s'" % (choice, steamid))

def stock_ammo():
    user = es.getcmduserid()
    auser = playerlib.getPlayer(user)
    auser.set('ammo', ['primary', '120'])
    auser.set('ammo', ['secondary', '120'])		
	
def GiveWeapons (userid):
    rifle = cplayers[userid][0]
    pistol = cplayers[userid][1]
    es.server.cmd('es_xgive %s player_weaponstrip' %userid)
    es.server.cmd('es_xfire %s player_weaponstrip strip' %userid)
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s %s' % (userid, pistol))
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s %s' % (userid, rifle))
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s weapon_knife' % (userid))
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s item_assaultsuit' % (userid))
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s weapon_hegrenade' % (userid))

def stats():
    user = es.getcmduserid()
    usersteam = es.getplayersteamid(user)
    (kills,deaths) = db.query("SELECT Kills,Deaths FROM UserSettings WHERE SteamID='%s'" % usersteam)[0]
    kd = (kills + .0) / deaths
    DDKills.modline(3, 'Kills : %s' % kills)
    DDKills.modline(4, 'Deaths : %s' % deaths)
    DDKills.modline(5, 'K/D Ratio : %.2f' % kd)
    DDKills.send(user)
    
def rank():
    global ranks
    global RankMenu
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    for rank in ranks:
        if ranks[rank][0] == steamid:      
            llimit = rank - 4
            if llimit < 1:
                llimit = 1
            ulimit = rank + 5
            if ulimit > int(dm_config['settings']['ranks_limit']):
                ulimit = int(dm_config['settings']['ranks_limit'])
            title = ('You are ranked # %d' %rank)
            ranks_menu(llimit,ulimit,userid,steamid,title)			            
            break
    else:
        es.tell(userid, '#multi', '%s You are not yet in the Top%s.' %(prefix,dm_config['settings']['ranks_limit']))    

def ranks():
    global ranks
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    es.dbgmsg(1, '***** Ranks')
    if int(es.getargc()) == 3:
        arg1 = int(es.getargv(1))
        arg2 = int(es.getargv(2))
        if (arg2 - arg1) < 16:
            if es.getargv(0) == 'ranks':
                title = ('Ranked Players %d - %d' %(arg1,arg2))
                ranks_menu(arg1,arg2,userid,steamid,title)
            else:
                es.dbgmsg(0, '***** [hTP_SimpleDM]Ranked Players %d - %d' %(arg1,arg2))
        else:
            if es.getargv(0) == 'ranks':
                es.tell(userid, '#multi', '%s #green[Syntax Error] use:#default ranks # # - range up to 15' %prefix)  
                es.tell(userid, '#multi', '%s #greenEx.:#default ranks 15 30' %prefix)
            else:
                es.dbgmsg(0, '***** [Syntax Error] use: c_ranks # # - range up to 15')
                es.dbgmsg(0, '***** Example: c_ranks 15 30')
    else:
        if es.getargv(0) == 'ranks':
            es.tell(userid, '#multi', '%s #green[Syntax Error] use:#default ranks # # - range up to 15' %prefix)
            es.tell(userid, '#multi', '%s #greenEx.:#default ranks 15 30' %prefix)
        else:
            es.dbgmsg(0, '***** [Syntax Error] use: ranks # # - range up to 15')
            es.dbgmsg(0, '***** Example: ranks 15 30')

def top_ranks():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    amount = es.getargv(1)
    amount = int(amount)
    if amount > 15:
        amount = 15
        es.tell(userid, '#multi', '%s 15#lightgreen is the maximum value, top 15 shown.' %prefix)  
    es.dbgmsg(1, '***** Top ranks amount = %s' %amount)
    title = ('Top%s Players' %amount)
    ranks_menu(1,amount,userid,steamid,title)

def ranks_menu(llimit,ulimit,userid,steamid,title):
    global ranks 
    global RanksMenu
    es.dbgmsg(1, '***** llimit=%s ulimit=%s userid=%s steamid=%s' %(llimit,ulimit,userid,steamid))
    if popuplib.exists('ranksmenu'):
        popuplib.delete('ranksmenu')
    RanksMenu = popuplib.create('ranksmenu')
    RanksMenu.addline(title)
    RanksMenu.addline('--------------')
    RanksMenu.addline('Rank - Name: Kills Deaths - K/D')
    RanksMenu.addline(' ') 
    for i in range(int(llimit), int(ulimit)):
        try:
            if ranks[i]:
                kd = float(ranks[i][4])
                if ranks[i][0] == steamid:
                    RanksMenu.addline('->%d - %s: %s %s - %.2f' %(i,ranks[i][3],ranks[i][1],ranks[i][2],kd))
                else:
                    RanksMenu.addline('%d - %s: %s %s - %.2f' %(i,ranks[i][3],ranks[i][1],ranks[i][2],kd))    
        except:
            i -= 1
            RanksMenu.modline(1, 'Ranks %d - %d' %(llimit,ulimit))
            break
    RanksMenu.addline('-----------------')
    RanksMenu.addline('0. Close')
    RanksMenu.send(userid)
    popuplib.delete('ranksmenu')

def reset_ranks():
    userid = es.getcmduserid()
    if auth.isUseridAuthorized(userid, 'resetranks'):
        es.dbgmsg(1, '*****adminauth= %d' %auth.isUseridAuthorized(userid, 'resetranks'))
        db.execute("UPDATE UserSettings SET Kills='0',Deaths='0'")
        set_ranks()
        es.msg('#multi', '%s DeathMatch ranks have been reset.' %prefix)
    else:
        es.tell(userid, '#multi', '%s You do not have access to that command' %prefix)  

def set_ranks():
    global ranks
    ranks = {}
    es.dbgmsg(1, '*****Set Ranks')
    if not int(dm_config['settings']['rank_by']):
        es.dbgmsg(1, '***** Rank by Kills')
        ranks_temp = db.query("SELECT SteamID,Kills,Deaths,Name,KD FROM UserSettings WHERE Kills>%d ORDER BY Kills DESC LIMIT %d;" %(mkills,ranks_limit))
        i = 1
    else:
        es.dbgmsg(1, '***** Rank by K/D')
        ranks_temp = db.query("SELECT SteamID,Kills,Deaths,Name,KD FROM UserSettings WHERE Kills>%d ORDER BY KD DESC LIMIT %d;" %(mkills,ranks_limit))
        i = 1
    for player in ranks_temp:
        ranks[i] = (player)
        #es.dbgmsg(0, '***** rank=%s name=%s kills=%s deaths=%s kd=%s' %(i,ranks[i][3],ranks[i][1],ranks[i][2],ranks[i][4]))
        i += 1
    es.dbgmsg(1, '***** Ranks done') 

def round_end(event_var):
    es.dbgmsg(1, '*****Round End')
    es.dbgmsg(1, '*****Update ranks= %s' %dm_config['settings']['update_ranks_interval'])
    if int(dm_config['settings']['update_ranks_interval']):
        es.dbgmsg(1, '***** round end set ranks')
        set_ranks()

def es_map_start(event_var):
    global ranks
    popuplib.close('dmm_popup', playerlib.getUseridList('#human'))
    popuplib.close('dmp_popup', playerlib.getUseridList('#human'))
    popuplib.close('dmr1_popup', playerlib.getUseridList('#human'))
    date = datetime.date.today() - datetime.timedelta(int(dm_config['settings']['clear_inactive_users']))
    es.dbgmsg(1, '***** delete date = %s' %date)
    set_ranks()
    db.execute("DELETE FROM UserSettings WHERE LastConnect<'%s'" %date)     

def player_activate(event_var):
    if event_var['es_steamid'] not in ('STEAM_ID_PENDING','BOT'):
        es.tell (event_var['userid'], '#multi', '#green[DM Commands]#default \'guns\' \'ammo\' \'kills\' \'top #\' \'rank\' \'ranks # #\'')
        getPlayer(event_var['userid'], event_var['es_steamid'])    
    else:
        es.tell (event_var['userid'], '#multi', '%s Your STEAM_ID has not been validated yet.' %prefix)
        es.tell (event_var['userid'], '#multi', '%s Cannot load your settings.' %prefix)
        es.tell (event_var['userid'], '#multi', '%s You will be given random weapons until validation.' %prefix)
        getbotweapons(event_var['userid'])  

def getPlayer(userid,steamid):
    if not es.isbot(userid):
        settings = db.query("SELECT Rifle,Pistol,SendMenu,Name FROM UserSettings WHERE SteamID='%s'" % steamid)
        es.dbgmsg(1, '***** %s' %settings)
        name = es.getplayername(userid)
        es.dbgmsg(1, '***** name= %s' %name)
        userid = int(userid)        
        if not settings:
            db.execute("INSERT INTO UserSettings ('SteamID', 'Name', 'Rifle', 'Pistol', 'SendMenu', 'Kills', 'Deaths', 'LastConnect') VALUES ('%s', '%s', 'weapon_m4a1', 'weapon_deagle', '1', 0, 0, '%s')" % (steamid, name, datetime.date.today()))
            cplayers[userid] = ('weapon_m4a1', 'weapon_deagle', '1')
        else:
            settings = settings[0] 
            cplayers[userid] = settings
            es.dbgmsg(1, '***** before %s' %cplayers)
            if name == cplayers[userid][3]:
                db.execute("UPDATE UserSettings SET LastConnect='%s' WHERE SteamID='%s'" %(datetime.date.today(),steamid))
            else:
                db.execute("UPDATE UserSettings SET Name='%s',LastConnect='%s' WHERE SteamID='%s'" %(name,datetime.date.today(),steamid))
            cplayers[userid] = (cplayers[userid][0],cplayers[userid][1],cplayers[userid][2])
            es.dbgmsg(1, '***** after %s' %cplayers)

def player_changename(event_var):
    es.dbgmsg(1, '***** %s %s' %(event_var['oldname'], event_var['newname']))
    db.execute("UPDATE UserSettings SET Name='%s' WHERE SteamID='%s'" %(event_var['newname'],event_var['es_steamid']))

def player_disconnect(event_var):
    global cplayers
    userid = event_var['userid']
    userid = int(userid)
    steamid = event_var['es_steamid']
    if steamid != 'BOT':
        es.dbgmsg(1, '***** before %s' %cplayers) 
        kills = db.query("SELECT Kills FROM UserSettings WHERE SteamID='%s'" %steamid)[0]
        es.dbgmsg(1, '***** kills= %s' %kills) 
        es.dbgmsg(1, '***** kills[0]= %s' %kills[0]) 
        if kills[0]:
            db.execute("UPDATE UserSettings SET Rifle='%s',Pistol='%s',SendMenu='%s' WHERE SteamID='%s'" %(cplayers[userid][0],cplayers[userid][1],cplayers[userid][2],steamid)) 
            es.dbgmsg(1, '*****updating db')
            del cplayers[userid]
        else:
            es.dbgmsg(1, '*****deleting from db')
            db.execute("DELETE FROM UserSettings WHERE SteamID='%s'" %steamid)
            del cplayers[userid]
        es.dbgmsg(1, '***** after %s' %cplayers)	

def player_death(event_var):
    global rw
    gamethread.delayed(2.5, es.server.cmd, 'est_spawn %s' % event_var['userid'])
    es.dbgmsg(1, '*****attackerteam = %s' %event_var['es_attackerteam'])
    if event_var['es_userteam'] != event_var['es_attackerteam'] and event_var['es_attackerteam'] in ('2','3'):
        attackersteam = event_var['es_attackersteamid']
        steamid = event_var['es_steamid']
        if attackersteam != 'BOT':
            if steamid != 'BOT':
                db.execute("UPDATE UserSettings SET Deaths=(SELECT sum(Deaths+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
                kd_update(steamid)
                kd_update(attackersteam)
                #db.execute("UPDATE UserSettings SET KD=(SELECT sum((Kills + .0) / Deaths) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(attackersteam,attackersteam))

            es.dbgmsg(1, '*****count_bot_kills_deaths= %s' %dm_config['settings']['count_bot_kills_deaths'])
            if dm_config['settings']['count_bot_kills_deaths'] == '1':
                es.dbgmsg(1, '***** sql add kill')
                db.execute("UPDATE UserSettings SET Kills=(SELECT sum(Kills+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(attackersteam,attackersteam))
                kd_update(attackersteam)

        es.dbgmsg(1, '*****count_bot_kills_deaths= %s' %dm_config['settings']['count_bot_kills_deaths'])
        if dm_config['settings']['count_bot_kills_deaths'] == '1':
            if event_var['es_steamid'] != 'BOT':
                es.dbgmsg(1, '***** sql add death')
                db.execute("UPDATE UserSettings SET Deaths=(SELECT sum(Deaths+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
                kd_update(steamid)

    rw += 1
    if rw > 10:
        remove_weapons()
        rw = 0

def kd_update(steamid):
    if db.execute("SELECT Deaths FROM UserSettings WHERE SteamID='%s'" %steamid):
        db.execute("UPDATE UserSettings SET KD=(SELECT sum((Kills + 0.) / Deaths) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
    else:
        db.execute("UPDATE UserSettings SET KD=(SELECT sum((Kills + 0.)) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))	

def player_team(event_var):
    if event_var['disconnect'] and int(event_var['team']) > 1:
        gamethread.delayed(1, es.server.cmd, 'est_spawn %s 1' % event_var['userid'])
	
def player_spawn(event_var):
    if int(event_var['es_userteam']) > 1:
        userid = int(event_var['userid'])
        steamid = event_var['es_steamid']
        current_player = playerlib.getPlayer(userid)
        current_player.set('health', 999)
        gamethread.delayed(3, current_player.set, ('health', 100))
        if steamid not in ('BOT', 'STEAM_ID_PENDING'):
            if cplayers[userid]:
                es.dbgmsg(1, '***** sendmenu = %s' %cplayers[userid][2])
                if cplayers[userid][2] == '1':
                    if not popuplib.isqueued('dmm_popup', userid):
                        popuplib.send('dmm_popup', userid)
                else:
                    GiveWeapons(userid)
            else:
                getplayer(userid,steamid)
        else:            
            getbotweapons(userid)

def round_start(event_var):
    gamethread.delayed(3,remove_weapons())
    userid = int(es.getuserid())
    if userid:
        es.server.cmd('es_xfire %d func_buyzone disable' % userid)

def send_main():
    userid = es.getcmduserid()
    DMMain.send(userid)
    cplayers[userid] = (cplayers[userid][0],cplayers[userid][1], '1')
    es.tell (userid, '#multi', '%s Menu Enabled' %prefix)	
	
def remove_weapons():
    es.server.cmd('est_DeleteRagDolls')
    es.server.cmd('est_RemoveIdle weapon')
    es.server.cmd('est_RemoveIdle item')

def getbotweapons(userid):
    pistol = random.choice(('weapon_glock', 'weapon_deagle', 'weapon_usp', 'weapon_elite', 'weapon_usp', 'weapon_p228', 'weapon_fiveseven'))
    primary = random.choice(('weapon_m4a1', 'weapon_ak47', 'weapon_awp', 'weapon_mp5navy', 'weapon_p90', 'weapon_galil', 'weapon_scout', 'weapon_sg552', 'weapon_aug'))
    es.server.cmd('es_xgive %s player_weaponstrip' %userid)
    es.server.cmd('es_xfire %s player_weaponstrip strip' %userid)
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s %s' % (userid, pistol))
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s %s' % (userid, primary))
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s weapon_knife' % (userid))
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s item_assaultsuit' % (userid))
    gamethread.delayed(0.2, es.server.cmd, 'es_xgive %s weapon_hegrenade' % (userid))

def weapon_reload(event_var):
    es.dbgmsg(1, '*****Weapon reload userid = %s' %event_var['userid'])
    auser = playerlib.getPlayer(event_var['userid'])
    es.dbgmsg(1, '*****auser= %s' %auser)
    auser.set('ammo', ['primary', '120'])
    auser.set('ammo', ['secondary', '120'])	
   
def unload():
    popuplib.delete('dmm_popup')
    popuplib.delete('dmkills_popup')
    popuplib.delete('dmp_popup')
    popuplib.delete('dmr1_popup')
    es.unregsaycmd('guns')
    es.unregsaycmd('ammo')
    es.unregsaycmd('stats')
    es.unregsaycmd('rank')
    es.unregsaycmd('top')
    es.unregsaycmd('resetranks')
    es.unregsaycmd('ranks')